Package: WECCA
Type: Package
Title: Weighted clustering of array CGH data
Version: 0.40
Date: 2012-06-15
Author: Wessel N. van Wieringen
Maintainer: Wessel N. van Wieringen <wvanwie@few.vu.nl>
Depends: CGHcall, CGHregions, flexmix
Description: Weighted hierarchical clustering of array CGH data using (call probabilities).
License: GPL version 2 or newer
LazyLoad: yes
Packaged: 2012-06-15 12:41:37 UTC; w.vanwieringen

impScores.plot <-
function(impScores.table, yaxis.max=10, lastchr=22, color="red"){

######################################################################################################
#
# function that plots importance scores
#
######################################################################################################

# internal function needed for plotting
rangebpchr <- function(chr, data){
datchr <- data[data[,1]==chr,]
en <- nrow(datchr)
rangebp <- datchr[en,2]
return(rangebp/en)
}

# blow up to total numer of features on the array
impScores.table.extended <- numeric()
for (r in 1:dim(impScores.table)[1]){
junk <- matrix(rep(impScores.table[r,-c(4:5)], impScores.table[r,5]), ncol=4, byrow=TRUE)
step.size <- as.numeric(round((impScores.table[r,4] - impScores.table[r,3]) / (impScores.table[r,5]-1), digits=0))
grid <- impScores.table[r,3] + step.size * c(0:(impScores.table[r,5]-1))
junk[,3] <- grid
impScores.table.extended <- rbind(impScores.table.extended, junk)
}

# extract relevant info from the extended table
bppos <- impScores.table.extended[,3]
chrom <- impScores.table.extended[,2]
chrbp <- cbind(chrom, bppos) 
impScores <- impScores.table.extended[,4]

# dit is de schaling. scaleall is een vector ter lengte aantal datapunten; de waardes zijn constant per 
# chromosoom. In de barplot functie zie je dat de wijdte van de bars (1 bar per clone) wordt 
# opgeschaald met scaleall. Zo zorg ik ervoor dat de lengte van een chromosoom klopt. De precieze
# x-as positie klopt niet met de bp-positie maar dat is ook niet zo belangrijk
rangeallchr <- sapply(unique(chrom),rangebpchr,data=chrbp)
sca <- rangeallchr/max(rangeallchr)
scaleall <- sapply(chrom,function(x)sca[x])
chrom.labels <- as.character(unique(chrom))

# set plot border
par(mar = c(5, 4, 4, 4) + 0.2)
# plot
G <- barplot(rep(0, length(impScores)), width=scaleall, border="black",space=0,col=FALSE, las=1, cex.axis=1, cex.lab=1, ylim=c(0, min(max(impScores)+1, yaxis.max)), beside=TRUE, ylab="importance score", xlab="chromosome", main="Importance score plot")
barplot(rep(0, length(impScores)), width=scaleall, border="black",space=0,col=FALSE, las=1, cex.axis=1, cex.lab=1, ylim=c(0, min(max(impScores)+1, yaxis.max)), beside=TRUE, ylab="importance score", xlab="chromosome", main="Importance score plot")
lines(y=t(impScores),x=G, type="l", col="red", lwd=1.5)
lim <- par("usr")
lim[3:4] <- c(-5,5)
par(usr=lim)
# add vert lines at chromosome ends
chromnew <- table(chrom) * sca
for (iii in 1:length(cumsum(chromnew))) {
segments(cumsum(chromnew)[[iii]],-5,cumsum(chromnew)[[iii]],5,lty=2)
}
box()
# add chromomsome labels
ax <- (cumsum(chromnew) + c(0,cumsum(chromnew)[-length(cumsum(chromnew))])) / 2
axis(side=1, at=ax, labels=chrom.labels, cex=.2, lwd=.25, las=1, cex.axis=1, cex.lab=1)

}

WECCA.heatmap <-
function (cghdata.regioned, dendrogram,...){
######################################################################################################
# heatmap with hard calls and chrosome indicator 
######################################################################################################

# calculated number of classes used
nclass <- length(unique(as.numeric(cghdata.regioned$hardcalls))) #28/7/2011: adjustment MvdW

# Preparation of the plotting of the heatmap
# Generate alternating colors for chromosomes.
chr.color <- rep("blue", dim(cghdata.regioned$hardcalls)[1])
ids <- ((cghdata.regioned$ann[, 1]%%2) == 0)
chr.color[ids] <- c("yellow")

# Generate labels for begin points of chromosomes.    
Y <- rep(FALSE, dim(cghdata.regioned$hardcalls)[1])
    for (i in 2:(dim(cghdata.regioned$ann)[1])) {
        if ((cghdata.regioned$ann[i - 1, 1] != cghdata.regioned$ann[i, 1])) {
            Y[i] <- TRUE
        }
}
Y[1] <- TRUE
begin.chr <- rep("", dim(cghdata.regioned$ann)[1])
begin.chr[Y] <- cghdata.regioned$ann[Y, 1]

# The heatmap is plotted.    
color.coding <- c("red", "black", "green", "white")[1:nclass]
heatmap(cghdata.regioned$hardcalls, Colv = as.dendrogram(dendrogram), 
        Rowv = NA, col = color.coding, labRow = begin.chr,RowSideColors = chr.color, 
        scale = "none",...) #28/7/2011: adjustment MvdW, added ... to allow for using heatmap options in the mother function
}

regioning <-
function (cghdata.called, threshold = 1e-05){

#cghdata.called<-WiltingCalled;threshold<-0.0001

    find.reg.modus <- function(x) {
        splitter <- list()
        splitter[[1]] <- c(1)
        index.temp <- 1
        j <- 1
        for (i in 1:(dim(x)[1] - 1)) {
            if (all(x[i, ] == x[i + 1, ])) {
                index.temp <- c(index.temp, i + 1)
                splitter[[j]] <- index.temp
            }
            else {
                index.temp <- i + 1
                j <- j + 1
                splitter[[j]] <- index.temp
            }
        }
        region.details <- NULL
        for (i in 1:length(splitter)) {
            region.details <- rbind(region.details, c(min(splitter[[i]]), 
                max(splitter[[i]])))
        }
        modus <- which.max(region.details[, 2] - region.details[, 
            1] + 1)
        return(x[region.details[modus[1], 1], ])
    }
    cat("CGHregions of hard call data...")
    cghdata.regions <- CGHregions(cghdata.called, averror = threshold)
    cat("...done", "\n")
    print(paste("threshold used:", threshold, sep = " "))
    calls.annotation <- pData(featureData(cghdata.called))
    regions.annotation <- pData(featureData(cghdata.regions))
    cat("Map regions to clones...")
    reg.to.clones <- list()
    counter <- 0
    for (chr in 1:max(calls.annotation[, 1])) {
        reg.ann.temp <- regions.annotation[regions.annotation[, 
            1] == chr, 1:4]
        for (r in 1:dim(reg.ann.temp)[1]) {
            counter <- counter + 1
            A1 <- which(calls.annotation[, 1] == chr)
            A2 <- which(calls.annotation[, 2] >= reg.ann.temp[r, 
                2])
            A3 <- which(calls.annotation[, 2] <= reg.ann.temp[r, 
                3])
            reg.to.clones[[counter]] <- intersect(intersect(A1, 
                A2), A3)
        }
    }
#    cat("...done", "\n")
#    cghdata.probs <- numeric()
#    for (i in 1:dim(calls(cghdata.called))[2]) {
#        cghdata.probs <- cbind(cghdata.probs, cbind(probloss(cghdata.called)[, 
#            i], probnorm(cghdata.called)[, i], probgain(cghdata.called)[, 
#            i], probamp(cghdata.called)[, i]))
#    }
#    cat("Calculate mode soft call signature for each region...")
#    cghdata.regprobs <- numeric()
#    for (i in 1:length(reg.to.clones)) {
#        cghdata.regprobs <- rbind(cghdata.regprobs, find.reg.modus(cghdata.probs[reg.to.clones[[i]], 
#            , drop = FALSE]))
#    } 
#    rtc <- 1:10;cghdata.call <- calls

    #MODIFIED BY MvdW 25/7/2012, FOR MEMORY EFFICIENCY
    cat("Calculate mode soft call signature for each region...")
    cghdata.regprobs <- numeric()
    for (i in 1:length(reg.to.clones)) {
        rtc <- reg.to.clones[[i]]
        cghdatrtc <- cghdata.called[rtc,,drop=FALSE]
        cghdata.probs <- numeric()
        for (j in 1:dim(calls(cghdata.called))[2]) {
        cghdata.probs <- cbind(cghdata.probs, cbind(probloss(cghdatrtc)[, 
            j], probnorm(cghdatrtc)[, j], probgain(cghdatrtc)[, 
            j], probamp(cghdatrtc)[, j]))
        }
        cghdata.regprobs <- rbind(cghdata.regprobs, find.reg.modus(cghdata.probs))
    }
    #END MODIFICATION

    cat("...done", "\n")
    softcalls.samplenames <- character()
    for (i in 1:dim(calls(cghdata.called))[2]) {
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            3) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_"), 
                  colnames(regions(cghdata.regions))[i], sep = ""))
        }
        if (dim(cghdata.regprobs)[2]/dim(calls(cghdata.called))[2] == 
            4) {
            softcalls.samplenames <- c(softcalls.samplenames, 
                paste(c("probloss_", "probnorm_", "probgain_", 
                  "probamp_"), colnames(regions(cghdata.regions))[i], 
                  sep = ""))
        }
    }
    colnames(cghdata.regprobs) <- softcalls.samplenames
    rownames(cghdata.regprobs) <- rownames(regions(cghdata.regions))
    regdata <- list()
    regdata$ann <- regions.annotation
    regdata$hardcalls <- regions(cghdata.regions)
    regdata$softcalls <- cghdata.regprobs
    return(regdata)
}

WECCAsc <-
function(cghdata.regioned, dist.measure="KLdiv", linkage="ward", weight.type="all.equal"){

######################################################################################################
#
# WECCA for call probabilities
#
######################################################################################################

reg.dist.ordinal <- function(one.reg.probs.two.samples, nclass){

##############################################################################################
# 
# Function that calculates the difference between the cumulative call
# probability distributions of two regions.
#
##############################################################################################

return(sum(abs(cumsum(one.reg.probs.two.samples[1:nclass]) - cumsum(one.reg.probs.two.samples[-c(1:nclass)]))))
}

reg.dist.KLdiv <- function(one.reg.probs.two.samples, nclass, precision){

##############################################################################################
# 
# Function that calculates the difference between the cumulative call
# probability distributions of two regions.
#
##############################################################################################

# return(one.reg.probs.two.samples[1:nclass] * log(one.reg.probs.two.samples[-c(1:nclass)]) + one.reg.probs.two.samples[-c(1:nclass)] * log(one.reg.probs.two.samples[1:nclass]))
KL.matrix <- KLdiv(cbind(one.reg.probs.two.samples[1:nclass], one.reg.probs.two.samples[-c(1:nclass)]), overlap=FALSE, eps=max((min(one.reg.probs.two.samples))^2, precision))
return((KL.matrix[1,2] + KL.matrix[2,1])/2)
}

##############################################################################################
# 
# Function that constructs the agreement similarity matrix with complete linkage.
#
##############################################################################################

weight.dist.matrix.ordinal <- function(cgh.reg.probs, nclass, weights){

##############################################################################################
# 
# Function that constructs the distance matrix with the distance measure 
# that takes the ordinality of the calls into account.
# It calculates the distance between the cumulative distributions for each region.
#
##############################################################################################

dist.mat <- matrix(0, nrow=dim(cgh.reg.probs)[2]/nclass, ncol=dim(cgh.reg.probs)[2]/nclass)
for (i1 in 1:(dim(cgh.reg.probs)[2] / nclass - 1)){
for (i2 in (i1+1):(dim(cgh.reg.probs)[2] / nclass)){
corresponding.cols <- c(nclass * (i1-1) + c(1:nclass), nclass*(i2-1) + c(1:nclass))
dist.mat[i2,i1] <- sum(weights * apply(cgh.reg.probs[,corresponding.cols], 1, reg.dist.ordinal, nclass=nclass))
dist.mat[i1,i2] <- dist.mat[i2,i1]
}
}
return(dist.mat)
}

weight.dist.matrix.KLdivergence <- function(cgh.reg.probs, nclass, weights){

##############################################################################################
# 
# Function that constructs the distance matrix with the distance measure 
# that does not take the ordinality of the calls into account.
# It calculates the Kullback-Leibler divergence between the distributions for each region.
#
##############################################################################################

precision <- sort(unique(as.numeric(cgh.reg.probs)))[2:201]
precision <- min(precision[(precision!=0)], na.rm=TRUE)/10

dist.mat <- matrix(0, nrow=dim(cgh.reg.probs)[2]/nclass, ncol=dim(cgh.reg.probs)[2]/nclass)
for (i1 in 1:(dim(cgh.reg.probs)[2]/nclass - 1)){
for (i2 in (i1+1):(dim(cgh.reg.probs)[2] / nclass)){
corresponding.cols <- c(nclass * (i1-1) + c(1:nclass), nclass * (i2-1) + c(1:nclass))
dist.mat[i2,i1] <- sum(weights * apply(cgh.reg.probs[,corresponding.cols], 1, reg.dist.KLdiv, nclass=nclass, precision=precision))
dist.mat[i1,i2] <- dist.mat[i2,i1]
}
}
return(dist.mat)
}

# START OF WECCAsc FUNCTION

# extract cgh data from data object
cgh.reg.probs <- cghdata.regioned$softcalls

# calculated number of classes used
nclass <- dim(cghdata.regioned$softcalls)[2] / dim(cghdata.regioned$hardcalls)[2]

# calculate number of samples present
nosamp <- dim(cghdata.regioned$softcalls)[2]

# determine weights
cat("Weight calculation...")
if (weight.type == "all.equal"){
weights <- rep(1, dim(cgh.reg.probs)[1])
}
if (weight.type == "heterogeneity"){
total.call.probs <- numeric()
for (k in 1:nclass){
total.call.probs <- cbind(total.call.probs, rowSums(cgh.reg.probs[,nclass*(c(1:(dim(cgh.reg.probs)[2]/nclass)) - 1) + k])/(dim(cgh.reg.probs)[2]/nclass))
}
weights.entropy <-  apply(total.call.probs, 1, function(x){ x*log(x, 2) })
weights.entropy[is.na(weights.entropy)] <- 0
weights.entropy <-  -colSums(weights.entropy)
weights <- dim(cgh.reg.probs)[1] * weights.entropy / sum(weights.entropy)
}
cat("...done.", "\n")

# calculate the distance matrix
cat("Distance matrix calculation...")
if (dist.measure == "KLdiv"){
dist.mat <- weight.dist.matrix.KLdivergence(cgh.reg.probs, nclass, weights)
} else {
dist.mat <- weight.dist.matrix.ordinal(cgh.reg.probs, nclass, weights)
}
cat("...done.", "\n")

# construct dendrogram
cat("Dendrogram construction...")
dendro <- hclust(as.dist(dist.mat), method=linkage)
cat("...done.", "\n")

# return dendro
return(dendro)
}

sample.cluster.table <-
function(cghdata.regioned, dendrogram, nclusters){

######################################################################################################
#
# generate table of which samples belong to which cluster
#
######################################################################################################

# if number of clusters exceeds the number of samples: error
if (nclusters > dim(cghdata.regioned$hardcalls)[2]){ stop("more clusters than samples specified!") }

# generate table specifying which samples belong to which cluster
samples.in.clusters <- cutree(dendrogram, k=nclusters)
sample.cluster.results <- cbind(1:length(samples.in.clusters), colnames(cghdata.regioned$hardcalls), samples.in.clusters)
colnames(sample.cluster.results) <- c("sample.number", "sample.label", "cluster")

# return table
return(sample.cluster.results)
}

WECCAhc <-
function(cghdata.regioned, dist.measure="agree", linkage="ward", weight.type="all.equal"){

hierarchy2dendrogram <- function(hierarchy,order){  
##############################################################################################
# Function that transforms a hierarchy into a dendogram.
##############################################################################################
     tree <- list(merge = hierarchy[,1:2], height= hierarchy[,3], method=NULL, call = match.call(), order = order, dist.method = "whatever")
class(tree) <- "hclust" 
     return(tree) 
} 

merge.agree.avlink.weight <- function(X, a, corr){
#############################################################################################
# Function that constructs the heights and merging pattern,
# with the weighted agreement similarity and average linkage.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
D0 <- agree.comlink.weight.dist(X,clusters,a)
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-1/a)/(1-1/a),0))),ncol=dim(D0)[1]) }
        D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0),method="average")
hc
}

merge.agree.comtradlink.weight <- function(X,a,corr){
#############################################################################################
# Function that constructs the heights and merging pattern, with the weighted agreement 
# similarity and complete linkage in the traditional sense.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
D0 <- agree.comlink.weight.dist(X,clusters,a)
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-1/a)/(1-1/a),0))),ncol=dim(D0)[1]) }
        D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0),method="complete")
return(hc)
}

merge.agree.wardlink.weight <- function(X, a, corr){
#############################################################################################
# Function that constructs the heights and merging pattern, with the weighted agreement 
# similarity and complete linkage in the traditional sense.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
D0 <- agree.comlink.weight.dist(X,clusters,a)
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-1/a)/(1-1/a),0))),ncol=dim(D0)[1]) }
        D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0), method="ward")
return(hc)
}



merge.conc.comtradlink.weight <- function(X,a,corr,strict){
#############################################################################################
# Function that constructs the heights and merging pattern, with the weighted agreement 
# similarity and complete linkage in the traditional sense.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
      D0 <- conc.comlink.weight.dist(X,clusters,a,strict)
      if (!strict){ 
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-((a^2-2*a+1)/(2*a^2) + 1/a^3))/(1-((a^2-2*a+1)/(2*a^2) + 1/a^3)),0))),ncol=dim(D0)[1]) }
} else {
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-(a^2-2*a+1)/(2*a^2))/(1-(a^2-2*a+1)/(2*a^2)),0))),ncol=dim(D0)[1]) }
}
D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0),method="complete")
return(hc)
}


merge.conc.avlink.weight <- function(X,a,corr,strict){
#############################################################################################
# Function that constructs the heights and merging pattern,
# with the weighted agreement similarity and average linkage.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
        D0 <- conc.comlink.weight.dist(X,clusters,a,strict)
      if (!strict){ 
 if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-((a^2-2*a+1)/(2*a^2) + 1/a^3))/(1-((a^2-2*a+1)/(2*a^2) + 1/a^3)),0))),ncol=dim(D0)[1]) }
} else {
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-(a^2-2*a+1)/(2*a^2))/(1-(a^2-2*a+1)/(2*a^2)),0))),ncol=dim(D0)[1]) }
}
D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0),method="average")
return(hc)
}



merge.conc.wardlink.weight <- function(X,a,corr,strict){
#############################################################################################
# Function that constructs the heights and merging pattern,
# with the weighted agreement similarity and average linkage.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
        D0 <- conc.comlink.weight.dist(X,clusters,a,strict)
      if (!strict){ 
 if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-((a^2-2*a+1)/(2*a^2) + 1/a^3))/(1-((a^2-2*a+1)/(2*a^2) + 1/a^3)),0))),ncol=dim(D0)[1]) }
} else {
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-(a^2-2*a+1)/(2*a^2))/(1-(a^2-2*a+1)/(2*a^2)),0))),ncol=dim(D0)[1]) }
}
D0[upper.tri(D0)] <- t(D0)[upper.tri(t(D0))]
diag(D0) <- 1
hc <- hclust(as.dist(1-D0),method="ward")
return(hc)
}


merge.agree.comlink.weight <- function(X, a, corr){
#############################################################################################
# Function that constructs the heights and merging pattern,
# with the weighted agreement similarity and complete linkage.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
D0 <- agree.comlink.weight.dist(X,clusters,a)
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-1/a)/(1-1/a),0))),ncol=dim(D0)[1]) }
height <- NULL
merge <- NULL
for (j in 1:(dim(D0)[1]-1)){
height <- c(height,max(D0[lower.tri(D0)]))
if (height[length(height)] != 0){
   ind <- which(D0 == max(D0[lower.tri(D0)]),arr.ind=TRUE)[1,]
   new.cluster <- sort(c(clusters[[ind[1]]],clusters[[ind[2]]]))
} else {
               ind <- which(lapply(1:length(clusters), function(i, clusters){ is.na(max(match(clusters[[i]], clusters[[1]]))) }, clusters )==TRUE)[1]
   new.cluster <- sort(c(clusters[[1]],clusters[[ind]]))
}
for (i in 1:length(new.cluster)){ clusters[[new.cluster[i]]] <- new.cluster }
when <- rep(0,dim(D0)[1])
when[new.cluster] <- j
merge <- rbind(merge,when)
dist.vec <- NULL
for (i in 1:dim(D0)[1]){
    if (corr){ chance <- 1/a^(length(new.cluster)+length(clusters[i])) } else { chance <- 0 }
          dist.vec <- c(dist.vec, max((prob.agree.comlink.weight(X,1,c(new.cluster),c(clusters[[i]]),a)-chance)/(1-chance),0))
}
dist.vec[new.cluster] <- 0
for (i in 1:length(new.cluster)){ D0[new.cluster[i], ] <- dist.vec }
for (i in 1:length(new.cluster)){ D0[, new.cluster[i]] <- dist.vec }
D0[upper.tri(D0,diag=TRUE)] <- 0
}
return(list(merge=merge,height=height))
}



merge.conc.comlink.weight <- function(X,a,corr,strict){
#############################################################################################
# Function that constructs the heights and merging pattern,
# with the weighted concordance similarity and complete linkage.
##############################################################################################
clusters <- cluster.list(dim(X)[2]-1)
D0 <- conc.comlink.weight.dist(X,clusters,a,strict)
      if (!strict){ 
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-((a^2-2*a+1)/(2*a^2) + 1/a^3))/(1-((a^2-2*a+1)/(2*a^2) + 1/a^3)),0))),ncol=dim(D0)[1]) }
} else {
if (corr){ D0 <- matrix(as.numeric(lapply(as.numeric(D0), function(x) max((x-(a^2-2*a+1)/(2*a^2))/(1-(a^2-2*a+1)/(2*a^2)),0))),ncol=dim(D0)[1]) }
}
height <- NULL
merge <- NULL
for (j in 1:(dim(D0)[1]-1)){
height <- c(height,max(D0[lower.tri(D0)]))
if (height[length(height)] != 0){
ind <- which(D0 == max(D0[lower.tri(D0)]),arr.ind=TRUE)[1,]
new.cluster <- sort(c(clusters[[ind[1]]],clusters[[ind[2]]]))
} else {
ind <- which(lapply(1:length(clusters), function(i, clusters){ is.na(max(match(clusters[[i]], clusters[[1]]))) }, clusters )==TRUE)[1]
new.cluster <- sort(c(clusters[[1]],clusters[[ind]]))
}
for (i in 1:length(new.cluster)){ clusters[[new.cluster[i]]] <- new.cluster }
when <- rep(0,dim(D0)[1])
when[new.cluster] <- j
merge <- rbind(merge,when)
dist.vec <- NULL
for (i in 1:dim(D0)[1]){
if (!strict){ 
if (corr){ chance <- 2*((a-1)/(2*a))^(length(new.cluster)+length(clusters[i])) + 1/a^(2*(length(new.cluster)+length(clusters[i]))-1) } else { chance <- 0 }
} else {
if (corr){ chance <- 2*((a-1)/(2*a))^(length(new.cluster)+length(clusters[i])) } else { chance <- 0 }
}
dist.vec <- c(dist.vec, max((prob.conc.comlink.weight(X,1,c(new.cluster),c(clusters[[i]]),a,strict)-chance)/(1-chance),0))
}
dist.vec[new.cluster] <- 0
for (i in 1:length(new.cluster)){ D0[new.cluster[i], ] <- dist.vec }
for (i in 1:length(new.cluster)){ D0[, new.cluster[i]] <- dist.vec }
D0[upper.tri(D0,diag=TRUE)] <- 0
}
return(list(merge=merge,height=height))
}



build.dendro <- function(merge,height){
#############################################################################################
# Function that transforms the merging patterns into an efficient one and the permutation 
# order for efficient plotting, and turns this into a dendogram.
##############################################################################################
H1 <- apply(merge,2,cummax)
H <- NULL
for (j in 1:dim(merge)[2]){
H <- c(H,which(H1[,j]==min(H1[(H1[,j]>0),j]),arr.ind=TRUE)[1])
}
M <- (H==1)*c(1:dim(merge)[2])
M <- -1*M[(M!=0)]
for (j in 2:dim(merge)[1]){
id <- (merge[j,]!=0)*c(1:dim(merge)[2])
id <- id[(id!=0)]
H1a <- H1[j-1,id]
for (k1 in 1:length(id)){ 
if(H1a[k1]==0){ H1a[k1] <- -id[k1] }
}
M <- rbind(M,as.numeric(names(table(H1a))))
}
colnames(merge) <- c(1:dim(merge)[2])
for (j in 1:(dim(merge)[1]-1)){
merge <- merge[,order(merge[j,])]
}
order <- as.numeric(colnames(merge))
      mergePheight <- cbind(M,1-height)
colnames(mergePheight) <- NULL
rownames(mergePheight) <- NULL
hc <- hierarchy2dendrogram(mergePheight,order)
return(hc)
}

cluster.list <- function(n){
###################################################################################
# Function that constructs a list for n items equal to 1,...,n.
###################################################################################
c.null <- list()
for (i in 1:n){ c.null[[i]] <- c(i) }
return(c.null)
}


conc.comlink.weight.dist <- function(X,clusters,a,strict){
##############################################################################################
# Function that constructs the concordance similarity matrix with complete linkage.
##############################################################################################
dist.mat <- matrix(0,nrow=length(clusters),ncol=length(clusters))
for (i1 in 1:(length(clusters)-1)){
for (i2 in (i1+1):length(clusters)){
dist.mat[i2,i1] <- prob.conc.comlink.weight(X,1,as.numeric(clusters[i1]),as.numeric(clusters[i2]),a,strict)
}
}
return(dist.mat)
}



agree.comlink.weight.dist <- function(X,clusters,a){
##############################################################################################
# Function that constructs the agreement similarity matrix with complete linkage.
##############################################################################################
dist.mat <- matrix(0,nrow=length(clusters),ncol=length(clusters))
for (i1 in 1:(length(clusters)-1)){
for (i2 in (i1+1):length(clusters)){
dist.mat[i2,i1] <- prob.agree.comlink.weight(X,1,as.numeric(clusters[i1]),as.numeric(clusters[i2]),a)
}
}
return(dist.mat)
}



prob.agree.comlink.weight <- function(X,w.col,c1.cols,c2.cols,a){
##############################################################################################
# Function that calculates the weighted probability of agreement with complete linkage.
##############################################################################################
X1 <- matrix(X[,c1.cols+1],ncol=length(c1.cols),nrow=dim(X)[1])
X2 <- matrix(X[,c2.cols+1],ncol=length(c2.cols),nrow=dim(X)[1])
Xt <- cbind(X[,w.col],X1,X2)
index <- as.numeric(factor(apply(Xt[,2:dim(Xt)[2]], 1, paste, collapse=":"))) 
Xt <- cbind(Xt,index)
Xt <- Xt[order(Xt[,dim(Xt)[2]]),]
counter <- NULL
for (i in 1:length(table(index))){
counter <- c(counter, cumsum(Xt[(Xt[,dim(Xt)[2]]==i),dim(Xt)[2]])/i)
}
Xt <- cbind(Xt,counter,1)
Xc <- NULL
for (i in 1:length(table(index))){
Xc <- rbind(Xc,c(i,sum(Xt[(Xt[,dim(Xt)[2]-2]==i),dim(Xt)[2]]),Xt[((Xt[,dim(Xt)[2]-2]==i)&(Xt[,dim(Xt)[2]-1]==1)),2:(dim(Xt)[2]-3)],sum(Xt[(Xt[,dim(Xt)[2]-2]==i),1]),sum((Xt[(Xt[,dim(Xt)[2]-2]==i),1])^2)))
}
Pa <- 0
for (i in 1:a){
K <- rep(i,length(c1.cols)+length(c2.cols))
P <- matrix((Xc[,3:(length(c1.cols)+length(c2.cols)+2)]==K),ncol=(length(c1.cols)+length(c2.cols)+2)-(3-1))
H <- apply(P,1,prod)*c(1:dim(P)[1])
if (sum(H)>0){ Pa <- Pa + Xc[H,(length(c1.cols)+length(c2.cols)+3)] }
}
Pa <- Pa/sum(X[,w.col])
return(Pa)
}


prob.conc.comlink.weight <- function(X, w.col, c1.cols, c2.cols, a, strict){
##############################################################################################
# Function that calculates the weighted probability of concordance with complete linkage.
##############################################################################################

# select relevant data
X <- X[, c(w.col, c1.cols+1, c2.cols+1)]

# add column with indicator for each unique pattern
# X <- X[order(apply(X[,-1], 1, sum)), ]
# X <- X[,c(1, order(apply(X[,-1], 2, sum)) + 1)]
X <- cbind(X, as.numeric(factor(apply(X[,2:dim(X)[2]], 1, paste, collapse=":"))) )

# sort by pattern indicator
X <- X[order(X[,dim(X)[2]]), ]

# create intermediate variables for counting the response pattern frequency later
counter <- NULL
for (i in 1:length(table(X[,dim(X)[2]]))){
counter <- c(counter, cumsum(X[(X[,dim(X)[2]]==i), dim(X)[2]])/i)
}
X <- cbind(X, counter, 1)

# make table, denoted Xc
# 1st column: response pattern indicator
# 2nd column: response pattern frequency
# next columns: response patterns
# last two columns summary statistic of the weights
Xc <- NULL
for (i in 1:length(table(X[,dim(X)[2]-2]))){
Xc <- rbind(Xc, c(i, sum(X[(X[,dim(X)[2]-2]==i), dim(X)[2]]), 
X[((X[,dim(X)[2]-2]==i) & (X[, dim(X)[2]-1]==1)), 2:(dim(X)[2]-3)], 
sum(X[(X[,dim(X)[2]-2]==i), 1]), sum((X[(X[,dim(X)[2]-2]==i), 1])^2)))
}

m <- Xc[,3:(dim(Xc)[2]-2), drop=FALSE]

# find regions with tied aberrations pattern
equal <- function(X, P){ all(X==P) }
welke <- NULL
if (is.matrix(m)){
for (i in 1:a){ welke <- cbind(welke, apply(m, 1, equal, i)) }
}
if (is.matrix(m)==FALSE){
for (i in 1:a){ welke <- cbind(welke, all(m==i)) }
}

# calculate tie contribution of "tied regions" to concordance probability
if (is.matrix(welke)){
Pc.e <- sum(Xc[apply(welke, 1, any), dim(Xc)[2]-1]^2) - sum(Xc[apply(welke, 1, any), dim(Xc)[2]])
}
if (is.numeric(welke)){
Pc.e <- sum(Xc[apply(welke, 1, any), dim(Xc)[2]-1]^2) - sum(Xc[apply(welke, 1, any), dim(Xc)[2]])
}

# calculate 
Pc.l <- 0
bigger <- function(X, P){ all(X > P) }
for (i in 1:(nrow(Xc))){
Ui <- apply(Xc[, 3:(ncol(Xc)-2)], 1, "bigger", Xc[i, 3:(ncol(Xc)-2)]) * c(1:nrow(Xc))
Ui <- Ui[(Ui!=0)]    
if (length(Ui) != 0){ Pc.l <- Pc.l + Xc[i, (ncol(Xc)-1)] * sum(Xc[Ui, (ncol(Xc)-1)]) }
}

# sort out which definition of the concordance probability to use
if (!strict){ Pc <- (2*Pc.l + Pc.e) / (sum(X[, w.col])^2 - sum(X[, w.col]^2)) }
if (strict){ Pc <- (2*Pc.l) / (sum(X[, w.col])^2 - sum(X[, w.col]^2)) }

return(Pc)
}

##############################################################################################
# Actual start of function WECCAhc.
##############################################################################################

# make object for compatability
corr <- FALSE
strict <- FALSE
a <- dim(cghdata.regioned$softcalls)[2] / dim(cghdata.regioned$hardcalls)[2]

# determine weights
cat("Weight calculation...")
if (weight.type == "all.equal"){
weights <- rep(1, dim(cghdata.regioned$hardcalls)[1])
}

# the orginal wecca works with different coding of aberration. transform if coding differs.
if (min(cghdata.regioned$hardcalls) == -1){
cghdata.regioned$hardcalls <- cghdata.regioned$hardcalls + 2
}

if (weight.type == "heterogeneity"){
minCall <- min(cghdata.regioned$hardcalls)
maxCall <- max(cghdata.regioned$hardcalls)
callLevels <- seq(from=minCall, to=maxCall, by=1)
sumData <- t(apply(cghdata.regioned$hardcalls, 1, function(Z, callLevels){ as.numeric(table(factor(Z, levels=callLevels))) }, callLevels=callLevels)) / dim(cghdata.regioned$hardcalls)[2]
weights.entropy <-  apply(sumData, 1, function(x){ x*log(x, 2) })
weights.entropy[is.na(weights.entropy)] <- 0
weights.entropy <-  -colSums(weights.entropy)
weights <- dim(cghdata.regioned$hardcalls)[1] * weights.entropy / sum(weights.entropy)
}
cat("...done.", "\n")
data <- cbind(weights, cghdata.regioned$hardcalls)

cat("Distance matrix calculation and dendrogram construction...", "\n")
if (dist.measure=="conc" && linkage=="total" && corr==FALSE && strict==FALSE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.conc.comlink.weight(data,a,corr=FALSE,strict=FALSE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="conc" && linkage=="total" && corr==FALSE && strict==TRUE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.conc.comlink.weight(data,a,corr=FALSE,strict=TRUE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="conc" && linkage=="total" && corr==TRUE && strict==FALSE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.conc.comlink.weight(data,a,corr=TRUE,strict=FALSE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="conc" && linkage=="total" && corr==TRUE && strict==TRUE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.conc.comlink.weight(data,a,corr=TRUE,strict=TRUE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="conc" && linkage=="complete" && corr==FALSE && strict==TRUE){
dendro <- merge.conc.comtradlink.weight(data,a,corr=FALSE,strict=TRUE)
}
if (dist.measure=="conc" && linkage=="complete" && corr==FALSE && strict==FALSE){
dendro <- merge.conc.comtradlink.weight(data,a,corr=FALSE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="complete" && corr==TRUE && strict==TRUE){
dendro <- merge.conc.comtradlink.weight(data,a,corr=TRUE,strict=TRUE)
}
if (dist.measure=="conc" && linkage=="complete" && corr==TRUE && strict==FALSE){
dendro <- merge.conc.comtradlink.weight(data,a,corr=TRUE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="average" && corr==FALSE && strict==FALSE){
dendro <- merge.conc.avlink.weight(data,a,corr=FALSE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="average" && corr==FALSE && strict==TRUE){
dendro <- merge.conc.avlink.weight(data,a,corr=FALSE,strict=TRUE)
}
if (dist.measure=="conc" && linkage=="average" && corr==TRUE && strict==FALSE){
dendro <- merge.conc.avlink.weight(data,a,corr=TRUE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="average" && corr==TRUE && strict==TRUE){
dendro <- merge.conc.avlink.weight(data,a,corr=TRUE,strict=TRUE)
}
if (dist.measure=="conc" && linkage=="ward" && corr==FALSE && strict==FALSE){
dendro <- merge.conc.wardlink.weight(data,a,corr=FALSE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="ward" && corr==FALSE && strict==TRUE){
dendro <- merge.conc.wardlink.weight(data,a,corr=FALSE,strict=TRUE)
}
if (dist.measure=="conc" && linkage=="ward" && corr==TRUE && strict==FALSE){
dendro <- merge.conc.wardlink.weight(data,a,corr=TRUE,strict=FALSE)
}
if (dist.measure=="conc" && linkage=="ward" && corr==TRUE && strict==TRUE){
dendro <- merge.conc.wardlink.weight(data,a,corr=TRUE,strict=TRUE)
}
if (dist.measure=="agree" && linkage=="total" && corr==FALSE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.agree.comlink.weight(data,a,corr=FALSE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="agree" && linkage=="total" && corr==TRUE){
cat("NOTE: total-linkage may take a while...", "\n")
hier <- merge.agree.comlink.weight(data,a,corr=TRUE)
dendro <- build.dendro(hier$merge,hier$height)
}
if (dist.measure=="agree" && linkage=="complete" && corr==FALSE){
dendro <- merge.agree.comtradlink.weight(data,a,corr=FALSE)
}
if (dist.measure=="agree" && linkage=="complete" && corr==TRUE){
dendro <- merge.agree.comtradlink.weight(data,a,corr=TRUE)
}
if (dist.measure=="agree" && linkage=="average" && corr==FALSE){
dendro <- merge.agree.avlink.weight(data,a,corr=FALSE)
}
if (dist.measure=="agree" && linkage=="average" && corr==TRUE){
dendro <- merge.agree.avlink.weight(data,a,corr=TRUE)
}
if (dist.measure=="agree" && linkage=="ward" && corr==FALSE){
dendro <- merge.agree.wardlink.weight(data, a, corr=FALSE)
}
if (dist.measure=="agree" && linkage=="ward" && corr==TRUE){
dendro <- merge.agree.wardlink.weight(data, a, corr=TRUE)
}
cat("...done.", "\n")
return(dendro)
}

impScores.sc <-
function(cghdata.regioned, dendrogram, nclusters){

######################################################################################################
#
# function that calculates the maximum symmetric KL-divergence (importance scores)
#
######################################################################################################

# if number of clusters exceeds the number of samples: error
if (nclusters > dim(cghdata.regioned$hardcalls)[2]){ stop("more clusters than samples specified!") }

# calculated number of classes used
nclass <- dim(cghdata.regioned$softcalls)[2] / dim(cghdata.regioned$hardcalls)[2]

# extract sample to cluster ids
samples.in.clusters <- cutree(dendrogram, k=nclusters)
sample.cluster.results <- cbind(1:length(samples.in.clusters), colnames(cghdata.regioned$hardcalls), samples.in.clusters)
cluster.id <- as.numeric(sample.cluster.results[,3])

# calculate mean cluster call probability profile
data.clusts <- list()
mean.clusts <- list()
for (i in 1:max(cluster.id)){
id <- c(1:length(cluster.id))[(cluster.id==i)]
col.id <- numeric()
for (j in 1:length(id)){
col.id <- c(col.id, nclass * (id[j]-1) + c(1:nclass))
}
data.clusts[[i]] <- cghdata.regioned$softcalls[,col.id, drop=FALSE]
junk <- numeric()
for (k in 1:nclass){
junk <- cbind(junk, rowSums(data.clusts[[i]][,nclass * (c(1:length(id))-1) + k, drop=FALSE]) / length(id))
}
mean.clusts[[i]] <- junk
}

# calculate maximum KL-divergence between cluster pairs for all regions
max.sym.KLdiv <- numeric()
clust.dists <- NULL
for (j in 1:dim(mean.clusts[[1]])[1]){
densities <- numeric()
for (i in 1:max(cluster.id)){
densities <- cbind(densities, mean.clusts[[i]][j,])
}
precision <- as.numeric(densities)
precision <- min(precision[(precision!=0)], na.rm=TRUE)/10
        A <- KLdiv(densities, overlap = FALSE, eps = (precision)^2)
A <- A + t(A)
max.sym.KLdiv <- c(max.sym.KLdiv, max(A))
}

# generate table of importance scores
reg.imp.scores.table <- cbind(c(1:dim(cghdata.regioned$ann)[1]), cghdata.regioned$ann[,1:4], max.sym.KLdiv)
colnames(reg.imp.scores.table)[1] <- "reg.no"
reg.imp.scores.table <- data.matrix(reg.imp.scores.table)

# return table
return(reg.imp.scores.table)
}

\name{WECCA.heatmap}
\alias{WECCA.heatmap}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Heatmap plotting with a chromosome indicator bar added. }
\description{
 A heatmap generation of the WECCA clustering with chromosome info color-coded.
}
\usage{
WECCA.heatmap(cghdata.regioned, dendrogram, ...)
}
\arguments{
  \item{cghdata.regioned}{ A \code{list}-object as returned by the function \code{regioning}. }
  \item{dendrogram}{ Determines if and how the row dendrogram should be computed and reordered. Should be a dendrogram as returned by the function \code{WECCAsc} or \code{WECCAhc}. }
}
\details{
  This function is merely a thin wrapper to the heatmap function. It adds a color bar with chromosome information to the heatmap. Note that hard calls are used for heatmap plotting. 
}
\value{
  See \code{heatmap}.
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\seealso{ \code{heatmap}, \code{regioning}, \code{WECCAsc}, \code{WECCAhc}. }
\examples{
# generate object of class
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)

# clustering with soft.calls
dendrogram <- WECCAsc(WiltingRegioned)

# generate a heatmap of the found clustering
WECCA.heatmap(WiltingRegioned, dendrogram)
}

\name{WECCA-package}
\alias{WECCA-package}
\alias{WECCA}
\docType{package}
\title{
Weighted clustering of array CGH data
}
\description{
It clusters hierarchically the samples on the basis of their DNA copy number profile. 
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\references{ 
Van Wieringen, W.N., Van de Wiel, M.A., Ylstra, B. (2008), "Weighted clustering of called aCGH data", \emph{Biostatistics}, 9(3), 484-500.
}

\keyword{ package }

\name{WECCAhc}
\alias{WECCAhc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Weighted clustering of array CGH data. }
\description{
  Weighted distance matrix calculation, followed by dendrogram construction for regioned hard called array CGH data. 
}
\usage{
WECCAhc(cghdata.regioned, dist.measure = "agree", linkage = "ward", weight.type = "all.equal")
}
\arguments{
  \item{cghdata.regioned}{ A \code{list}-object as returned by the function \code{regioning}. }
  \item{dist.measure}{ The distance measure to be used. This is either \code{"agree"} (the agreement similarity) or \code{"conc"} (the concordance similarity). }
  \item{linkage}{ The linkage method to be used, like \code{"single"}, \code{"average"}, \code{"complete"}, \code{"ward"}, \code{"total"}. }
  \item{weight.type}{ Region weighting to be used in the calculation of the distance, either \code{"all.equal"} or \code{"heterogeneity"}. }
}
\details{
  The distance between the call profiles of all sample pairs are calculated using special distance measures suitable for this data type.
  The distance between the call signature of two regions is either defined via the agreement or concordance similarity.
  The distance between two call profiles is defined as a weighted average of the distances between individual regions.
  Region weighing currently implemented: no-weighing (all regions contribute equally to the overall distance), or heterogeneity weighing (weights are proportional to their Shannon's entropy).
  Once the distance matrix has been calculated, this is submitted to the \code{hclust} function, which clusters the samples hierarchically, returning a dendrogram.
}
\value{
  An object of class \code{hclust} which describes the tree produced by the clustering process. See \code{hclust} for a list of its components.
}
\references{ 
Van Wieringen, W.N., Van de Wiel, M.A., Ylstra, B. (2008), "Weighted clustering of called aCGH data", \emph{Biostatistics}, 9(3), 484-500.
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\seealso{ \code{dist}, \code{hclust}, \code{KLdiv}, \code{regioning} }
\examples{
# generate object of cghCall-class
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)

# clustering with soft.calls
dendrogram <- WECCAhc(WiltingRegioned)
}

\name{regioning}
\alias{regioning}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Regioning of called array CGH data }
\description{
Region construction in DNA copy number data using hard calls.
Given the resulting regions, the mediod call probability (soft calls) signature
of each region is calculated.}
\usage{
  regioning(cghdata.called, threshold = 1e-05)
}
\arguments{
  \item{cghdata.called}{ Object of class \code{cghCall}, containing annotion, calls and their probabilities. }
  \item{threshold}{ Threshold for the function \code{CGHregions}. It determines when a region is enforced. }
}
\details{
  CGHregions is applied to the calls of an object of class \code{cghCall} (as returned by CGHcall version 1.2.0 or higher). Using the regions demarcations the 
mediod call probability signatures are calculated. The matrix of these mediod signatures are considered 
the regioned soft call data (see warning below).
}
\value{
  A \code{list}-object with the following entries:
  \item{ann }{\code{data.frame} containing the annotation data of the regions. The first column contains the region's chromosome information, the second and third its start and end base pair, and the fourth column the number of features constituting the region.}
  \item{hardcalls }{The regioned hard calls \code{matrix}.}
  \item{softcalls }{The regioned soft calls \code{matrix}.}
}
\references{ 
Van de Wiel, M.A., Kim, K.I., Vosse, S.J., Van Wieringen, W.N., Wilting, S.M. , Ylstra, B. (2007), "CGHcall: an algorithm for calling aberrations for multiple array CGH tumor profiles", \emph{Bioinformatics}, 23, 892-894. 

Van de Wiel, M.A., Van Wieringen, W.N. (2007), "CGHregions: dimension reduction for array CGH data with minimal information loss", \emph{Cancer Informatics}, 2, 55-63.

Van Wieringen, W.N., Van de Wiel, M.A., Ylstra, B. (2007), "Normalized, segmented or called aCGH data?", \emph{Cancer Informatics}, 3, 331-337
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\section{Warning }{
  The current version of CGHregions is designed for hard calls only. This is likely to change in the near future, making this function obsolete.
}
\seealso{ \code{CGHregions}, \code{CGHcall} }
\examples{
# generate object of cghCall class object
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)
}

\name{impScores.sc}
\alias{impScores.sc}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Importance scores }
\description{
Given the clusters, the importance score of each feature is calculated.
This is defined as the maximum pairwise symmetrized
Kullback Leibler divergence.
These scores reflect which features are most discriminative between clusters.
}
\usage{
impScores.sc(cghdata.regioned, dendrogram, nclusters)
}
\arguments{
  \item{cghdata.regioned}{ A \code{list}-object as returned by the function \code{regioning.sc}. }
  \item{dendrogram}{ Determines if and how the row dendrogram should be computed and reordered. Should be a dendrogram as returned by \code{WECCAsc}. }
  \item{nclusters}{ An integer with the desired number of clusters. }
}
\value{
  A \code{matrix} whose first five columns contain annotation information and the sixth the region's importance score.
}
\references{ Insert ref to article where importance scores are calculated. }
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\seealso{ \code{KLdiv}, \code{regioning}, \code{WECCAsc} }
\examples{
# generate object of class
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)

# clustering with soft.calls
dendrogram <- WECCAsc(WiltingRegioned)

# generate a heatmap of the found clustering
WECCA.heatmap(WiltingRegioned, dendrogram)

# specify the number of clusters to be extracted from the dendrogram
nclusters <- 2
table.clusters.samples <- sample.cluster.table(WiltingRegioned, dendrogram, nclusters)

# calculate importance scores for each feature
impScores.table <- impScores.sc(WiltingRegioned, dendrogram, nclusters)
}

\name{sample.cluster.table}
\alias{sample.cluster.table}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Sample-cluster table }
\description{
  Cuts a the \code{WECCAsc} or \code{WECCAhc} generated dendrogram at a desired number of clusters. 
  Then, produces a \code{data.frame} telling which samples belong to which cluster.
}
\usage{
sample.cluster.table(cghdata.regioned, dendrogram, nclusters)
}
\arguments{
  \item{cghdata.regioned}{ A \code{list}-object as returned by \code{regioning.sc}. }
  \item{dendrogram}{ Determines if and how the row dendrogram should be computed and reordered. Should be a dendrogram as returned by \code{WECCAsc} or \code{WECCAhc}. }
  \item{nclusters}{ An integer with the desired number of clusters. }
}
\value{
  A \code{data.frame} with the first two columns containing the sample number and name, and the third column the cluster information.
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\seealso{ \code{\link{cutree}} }
\examples{
# generate object of class
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)

# clustering with soft.calls
dendrogram <- WECCAsc(WiltingRegioned)

# generate a heatmap of the found clustering
WECCA.heatmap(WiltingRegioned, dendrogram)

# specify the number of clusters to be extracted from the dendrogram
nclusters <- 2
table.clusters.samples <- sample.cluster.table(WiltingRegioned, dendrogram, nclusters)
}

\name{impScores.plot}
\alias{impScores.plot}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Importance score plot }
\description{
  Plots importance scores against genomic order.
}
\usage{
impScores.plot(impScores.table, yaxis.max = 10, lastchr = 22, color = "red")
}
\arguments{
  \item{impScores.table}{ Table containing region annotation information and importance scores as returned by the function \code{impScores.sc} or \code{impScores.hc}. }
  \item{yaxis.max}{ Maximum importance score to be plotted. }
  \item{lastchr}{ Integer corresponding to chromosome number. This is the last chromosome whose importance scores are included in the plot.}
  \item{color}{ Color of line connecting importance scores. }
}
\author{ Wessel N. van Wieringen: \email{wvanwie@few.vu.nl} }
\examples{
# generate object of class
data(WiltingCalled)

# make region data (soft and hard calls)
WiltingRegioned <- regioning(WiltingCalled)

# clustering with soft.calls
dendrogram <- WECCAsc(WiltingRegioned)

# generate a heatmap of the found clustering
WECCA.heatmap(WiltingRegioned, dendrogram)

# specify the number of clusters to be extracted from the dendrogram
nclusters <- 2
table.clusters.samples <- sample.cluster.table(WiltingRegioned, dendrogram, nclusters)

# calculate importance scores for each feature
impScores.table <- impScores.sc(WiltingRegioned, dendrogram, nclusters)

# plot importance scores
impScores.plot(impScores.table, yaxis.max=10, lastchr=22, color="red")
}
